INCLUDE 'gksw.f90'					 

MODULE tipi

TYPE tocka
	SEQUENCE
		REAL x,y,z
END TYPE tocka

TYPE rob
	SEQUENCE
		INTEGER t1,t2
END TYPE rob

TYPE ploskev
	SEQUENCE
		INTEGER st_robov
		INTEGER rob(10)
		TYPE (tocka) :: tezisce
		TYPE (tocka) :: normala
END TYPE ploskev

! struktura objekta:
TYPE objekt
	SEQUENCE
		LOGICAL poln, sprememba, izrisi
		INTEGER st_tock, st_robov, st_ploskev
		TYPE (tocka),POINTER :: v(:)
		TYPE (rob),POINTER :: e(:)
		TYPE (ploskev),POINTER :: pl(:)
		CHARACTER*80 komentar
END TYPE objekt

END MODULE

! glavni program ---------------------------------------------------
USE msflib
USE tipi
TYPE (objekt) :: obj(10)
TYPE (tocka) :: koor(3)
LOGICAL*2 tocke, robovi, ploskve, normale, pp
logical(4) obstaja
CHARACTER(1) key /'A'/
INTEGER plci, txci
REAL kot, merilo, fokus
INTEGER visina_crk, barva_osi, zoomfaktor
COMMON /plc/ plci
COMMON /txc/ txci
COMMON /config1/ merilo, kot, visina_crk, barva_osi, fokus, zoomfaktor
COMMON /config2/ tocke, robovi, ploskve, normale, pp
COMMON /kor/ koor
COMMON /podatki/ obj
CALL gopks()
CALL gswkvp(1,10,10,1023,767)
obj%sprememba=.false.
obj%poln=.false.
obj%izrisi=.false.
tocke=.true.
robovi=.true.
ploskve=.true.
normale=.true.
pp=.false.
koor(1)= tocka(1.,0.,0.)
koor(2)= tocka(0.,1.,0.)
koor(3)= tocka(0.,0.,1.)
merilo=1.
kot=2.5
fokus=1.4
barva_osi=6
visina_crk=20
plci=7
txci=5
zoomfaktor=0
CALL gsplci(plci)
CALL gstxci(txci)
CALL gschh(visina_crk)
inquire(file='delovni.prj',exist=obstaja)
if (obstaja) call beri_vse('delovni.prj')
WRITE(*,*)' Pritisni F1 za pomoc!!!'
DO WHILE (key .NE. '!')
	key=getcharqq()
	IF(ichar(key).eq.0) THEN
		key=getcharqq()
		IF (ichar(key).eq.59) CALL help
		IF (ichar(key).eq.64) CALL gor
		IF (ichar(key).eq.63) CALL dol
		IF (ichar(key).eq.66) CALL levo
		IF (ichar(key).eq.65) CALL desno
		CALL izris
	ELSE
	CALL delaj(key)
	ENDIF
ENDDO
CALL shrani_vse('delovni.prj')
DO i=1,10
NULLIFY(obj(i)%v)
NULLIFY(obj(i)%e)
NULLIFY(obj(i)%pl)
ENDDO
END
! konec glavnega programa

! izbere in izvede hot-key zahtevo
SUBROUTINE delaj(a)
USE tipi
USE msflib
CHARACTER*1 a
CHARACTER*30 ime
LOGICAL(4) obstaja
LOGICAL*2 tocke, robovi, ploskve, normale, pp
REAL fi, kot, merilo, fokus, max_x,min_x,max_y,min_y,max_r
TYPE (tocka) :: dv,scale,koor(3)
TYPE (objekt) :: obj(10)
INTEGER barva_osi, visina_crk, zoomfaktor
INTEGER plci
COMMON /plc/ plci
COMMON /config1/ merilo, kot, visina_crk, barva_osi, fokus, zoomfaktor
COMMON /config2/ tocke, robovi, ploskve, normale, pp
COMMON /podatki/ obj
COMMON /window/ max_x,min_x,max_y,min_y,max_r
COMMON /kor/ koor
SELECT CASE (a)
	CASE ('l','L')
		CALL beri_podatke
		CALL settextwindow(1,1,3,80)
		WRITE(*,*)' Pritisni F1 za pomoc'
		CALL init_window
		CALL izris
	CASE ('w','W')
		WRITE(*,'('' Shrani.'',/,'' Vpisi ime datoteke: '',\)')
		READ(*,'(A)')ime
		CALL shrani_vse(ime)
		CALL unplan
		CALL init_window
		CALL izris
	CASE ('r','R')
		WRITE(*,'('' Odpri.'',/,'' Vpisi ime datoteke: '',\)') 
		READ(*,'(a)')ime
		INQUIRE(file=ime,exist=obstaja)
		IF (obstaja) THEN 
			obj%sprememba=.false.
			obj%poln=.false.
			obj%izrisi=.false.
			DO i=1, 10
				NULLIFY(obj(i)%v)
				NULLIFY(obj(i)%e)
				NULLIFY(obj(i)%pl)
			ENDDO
			CALL plan
			CALL beri_vse(ime)
		ELSE
			PAUSE 'Datoteka ne obstaja! Pritisni Enter...'
			CALL gcls()
			CALL izris
		ENDIF
	CASE ('m','M')
		WRITE(*,'('' Translatorni premik (x,y,z): '',\)')
		READ(*,*,err=101)dv%x,dv%y,dv%z
!		CALL clearscreen($gwindow) 
		CALL kateri_objekti
		CALL plan
		CALL premik_tock(dv)
		CALL unplan
		CALL gcls()
		CALL izris
   		obj%sprememba=.false.
	CASE ('x','X','y','Y','z','Z')
		WRITE(*,'('' Kot rotacije okoli '',A1,'' v stopinjah: '',\)')a
		READ(*,*,err=101)fi
!		CALL clearscreen($gwindow) 
		fi=deg2rad(fi)
		CALL kateri_objekti
		CALL plan
		CALL rotacija_tocke(fi,.false.,a)
		CALL unplan
101		CALL gcls()
		CALL izris
		obj%sprememba=.false.
	CASE ('s','S')
		WRITE(*,'('' Faktor (x,y,z): '',\)')
		READ(*,*,err=101)scale%x,scale%y,scale%z
!		CALL clearscreen($gwindow) 
		CALL kateri_objekti
		CALL plan
		CALL skalacija_tocke(scale)
		CALL unplan
		CALL gcls()
		CALL izris
		obj%sprememba=.false.
	CASE ('d','D')
		CALL brisi_objekt
		CALL init_window
		CALL izris
	CASE ('h','H')
		CALL skri_objekt
		CALL izris
	CASE ('+')
		CALL zoom_in
		zoomfaktor=zoomfaktor+1
		CALL izris
	CASE ('-')
		CALL zoom_out
		zoomfaktor=zoomfaktor-1
		CALL izris
	CASE (' ')
		CALL init_window
		zoomfaktor=0
		CALL izris
	CASE ('1':'6')
		read(a,'(i1)')i
		fi=deg2rad(((-1)**i)*kot)
		obj%sprememba=obj%poln
		CALL rotacija_tocke(fi,.true.,char(119+((i+1)/2)))
		CALL gcls()
		CALL izris
		obj%sprememba=.false.
	CASE ('7','8')
		read(a,'(i1)')i
		fi=deg2rad(((-1)**(i+1))*kot)
		obj%sprememba=obj%poln
		CALL rotacija_tocke(fi,.true.,'x')
		CALL rotacija_tocke(fi,.true.,'y')
		CALL gcls()
		CALL init_window
		CALL izris
		obj%sprememba=.false.
	CASE ('P','p')
		obj%sprememba=obj%poln
		CALL plan
		CALL init_window
		CALL izris
		obj%sprememba=.false.
	CASE ('U','u')
		obj%sprememba=obj%poln
		CALL unplan
		CALL init_window
		CALL izris
		obj%sprememba=.false.
	CASE ('K','k')
		CALL konfiguracija
		CALL izris
END SELECT
ENDSUBROUTINE


! <F1>
SUBROUTINE help
USE msflib
character(1) a
CALL settextwindow(1,1,25,80)
WRITE(*,*)
WRITE(*,*)' Hot keys:'
WRITE(*,*)' ------------------------------------------'
WRITE(*,*)' L - Load - Beri podatke (en objekt)'
WRITE(*,*)' R - Read - Odpre shranjene objekte'
WRITE(*,*)' W - Write - Shrani vse objekte'
WRITE(*,*)' S - Scale - Skaliranje'
WRITE(*,*)' M - Move - Premik objekta'
WRITE(*,*)' P - Plan pogled'
WRITE(*,*)' U - UnPlan pogled'
WRITE(*,*)' H - Hide - Skri objekt'
WRITE(*,*)' X - Rotacija okoli x osi'
WRITE(*,*)' Y - Rotacija okoli y osi'
WRITE(*,*)' Z - Rotacija okoli z osi'
WRITE(*,*)' 1-2 Rotacija pogleda okoli x osi zaslona'
WRITE(*,*)' 3-4 Rotacija pogleda okoli y osi zaslona'
WRITE(*,*)' 5-6 Rotacija pogleda okoli z osi zaslona'
WRITE(*,*)' [space] Zoom to fit'
WRITE(*,*)' + - Zoom in'
WRITE(*,*)' - - Zoom out'
WRITE(*,*)' K - Konfiguracija'
WRITE(*,*)' [~] - konec'
WRITE(*,*)
WRITE(*,*) ' Pritisni karkoli...'
a=getcharqq()
CALL settextwindow(1,1,3,80)
CALL init_window
CALL izris
END SUBROUTINE

! skrije objekte
SUBROUTINE skri_objekt
USE msflib
USE tipi
TYPE (objekt) obj(10)
CHARACTER*1 a
COMMON /podatki/ obj
	CALL settextwindow(1,1,10,80)
	a='a'
	DO WHILE ((a.NE.'x').or.(a.ne.'X'))
	CALL clearscreen($gviewport)
	DO i=1,10
		IF (obj(i)%poln) THEN
			WRITE(*,'(i2,''.'',2x,A20,l2)')i,obj(i)%komentar,obj(i)%izrisi
		ENDIF
	ENDDO
	a=getcharqq()
	READ(a,'(i1)',err=10)i
	IF ((obj(i)%poln).and.(.not.obj(i)%izrisi)) THEN
		obj(i)%izrisi=.true.
		ELSE
		obj(i)%izrisi=.false.
	ENDIF
	goto 11
10  EXIT
!11	call izris
11	ENDDO
	CALL clearscreen($clearscreen)
ENDSUBROUTINE

! nastavi parametre izrisa
SUBROUTINE konfiguracija
USE msflib
INTEGER plci, visina_crk, txci, barva_osi
REAL kot, merilo, fokus
LOGICAL*2 tocke, robovi, ploskve, normale, inv, pp
CHARACTER(1) a
COMMON /pcl/    plci
COMMON /txc/    txci
COMMON /config1/ merilo, kot, visina_crk, barva_osi, fokus, zoomfaktor
COMMON /config2/ tocke, robovi, ploskve, normale, pp
103	FORMAT(/,' dolina koordinatne osi: ',\)
104	FORMAT(/,' Kot rotacije pogleda: ',\)
105	FORMAT(/,' Velikost crk: ',\)
106	FORMAT(/,' Barva crk: ',\)
107	FORMAT(/,' Barva koordinatne osi: ',\)
108 FORMAT(/,' Fokus perspektive: ',\)
	CALL settextwindow(1,1,14,80)
	write(*,*)' '
	a=' '
	DO WHILE (a .NE. '0')
	CALL clearscreen($clearscreen)
	WRITE(*,'('' d - dolzina koor. osi:.......... '',f5.2)')merilo
	WRITE(*,'('' b - Barva koordinatne osi:...... '',I2)  ')barva_osi
	WRITE(*,'('' k - Kot rotacije pogleda [deg]:. '',f5.2)')kot
	WRITE(*,'('' h - Velikost crk [5-99]:........ '',I2)  ')visina_crk
	WRITE(*,'('' t - Prikaz tock:................ '',L2)  ')tocke
	WRITE(*,'('' r - Prikaz robov:............... '',L2)  ')robovi
	WRITE(*,'('' p - Prikaz ploskev:............. '',L2)  ')ploskve
	WRITE(*,'('' n - Prikaz normal:.............. '',L2)  ')normale
	WRITE(*,'('' f - Fokus perspektive:.......... '',f5.2)')fokus
	WRITE(*,'('' i - Prikaz v perspektivi:....... '',L2)  ')pp
	WRITE(*,'(''--------------------------------------'')')
	WRITE(*,'('' 0. Izhod'')')
	a=getcharqq()
	SELECT CASE (a)
	CASE ('d')
		merilo=0.									 
		DO WHILE (merilo .le. 0)
			WRITE(*,103)
			READ (*,*)merilo
		ENDDO
	CASE ('b')
		barva_osi=0
		DO WHILE ((barva_osi.le.0).or.(barva_osi.gt.16))
			WRITE(*,107)
			READ (*,*)barva_osi
		ENDDO
	CASE ('k')
		kot=0
		DO WHILE ((kot.le.0).or.(kot.gt.90))
			WRITE(*,104)
			READ (*,*)kot
		ENDDO
	CASE ('h')
		visina_crk=0
		DO WHILE ((visina_crk.lt.5).or.(visina_crk.gt.99))
			WRITE(*,105)
			READ (*,*)visina_crk
		ENDDO
		CALL gschh(visina_crk)
	CASE ('t')
		tocke=inv(tocke)
	CASE ('r')
		robovi=inv(robovi)
	CASE ('p')
		ploskve=inv(ploskve)
	CASE ('n')
		normale=inv(normale)
	CASE ('i')
		pp=inv(pp)
	CASE ('f')
		fokus=0.
		DO WHILE (fokus.le.0)
			WRITE(*,108)
			READ (*,*)fokus
		ENDDO
	END SELECT
	ENDDO 
!	CALL clearscreen($gwindow) 
	CALL settextwindow(1,1,3,80)
	CALL init_window
	CALL izris
END SUBROUTINE

! funkcija negira logino vrednost
FUNCTION inv(l)
LOGICAL*2 inv,l
		IF (l) then
			inv=.false.
		  ELSE 
			inv=.true.
		ENDIF
ENDFUNCTION

! tocko pogleda priredi na 0,0,1
SUBROUTINE plan
USE tipi
TYPE (tocka) :: koor(3)
REAL fix,fiy,fiz
COMMON /fiji/ fix,fiy,fiz
COMMON /kor/ koor 
	fiz=atan(koor(1)%y/koor(1)%x)
	IF (sign(1.,koor(1)%x).eq.-1.) fiz=fiz+deg2rad(180.)
	CALL rotacija_tocke(-fiz,.true.,'z')
	fiy=-atan(koor(1)%z/koor(1)%x)
	CALL rotacija_tocke(-fiy,.true.,'y')
	fix=atan(koor(2)%z/koor(2)%y)
	IF (sign(1.,koor(2)%y).eq.-1.) fix=fix+deg2rad(180.)
	CALL rotacija_tocke(-fix,.true.,'x')
END SUBROUTINE

! razveljavi plan
SUBROUTINE unplan
REAL fix,fiy,fiz
COMMON /fiji/ fix,fiy,fiz
	CALL rotacija_tocke(fix,.true.,'x')
	CALL rotacija_tocke(fiy,.true.,'y')
	CALL rotacija_tocke(fiz,.true.,'z')
	fix=0
	fiy=0
	fiz=0
END SUBROUTINE

! priredi zaslon koordinatam objektov
SUBROUTINE init_window
USE msflib
USE tipi
INTEGER*2 maxx, maxy
REAL max_x,min_x,max_y,min_y,sirina,visina, max_r, r
TYPE (objekt) :: obj(10)
TYPE (tocka) koor(3)
record /videoconfig/ myscreen
COMMON /window/ max_x,min_x,max_y,min_y,max_r
COMMON /podatki/ obj
COMMON /kor/ koor
	CALL gcls
	CALL getvideoconfig( myscreen )
	maxx = myscreen.numxpixels - 1
	maxy = myscreen.numypixels - 1
	max_r=0.
	max_x=koor(1)%x
	min_x=koor(1)%x
	max_y=koor(1)%y
	min_y=koor(1)%y
d3: DO i=2,3
		IF (max_x.lt.koor(i)%x) max_x=koor(i)%x
		IF (min_x.gt.koor(i)%x) min_x=koor(i)%x
		IF (max_y.lt.koor(i)%y) max_y=koor(i)%y
		IF (min_y.gt.koor(i)%y) min_y=koor(i)%y
	ENDDO d3
	DO j=1, 10
		IF (obj(j)%izrisi) THEN
		DO i=1,obj(j)%st_tock
			r=sqrt(obj(j)%v(i)%x**2.+obj(j)%v(i)%y**2.+obj(j)%v(i)%z**2.)
			IF (max_x.lt.obj(j)%v(i)%x) max_x=obj(j)%v(i)%x
			IF (min_x.gt.obj(j)%v(i)%x) min_x=obj(j)%v(i)%x
			IF (max_y.lt.obj(j)%v(i)%y) max_y=obj(j)%v(i)%y
			IF (min_y.gt.obj(j)%v(i)%y) min_y=obj(j)%v(i)%y
			IF (max_r.lt.r) max_r=r
		ENDDO
		ENDIF
	ENDDO
	sirina=max_x-min_x
	visina=max_y-min_y
	min_x=min_x-.1*(sirina)
	max_x=max_x+.1*(sirina)
	min_y=min_y-.1*(visina)
	max_y=max_y+.1*(visina)
	IF ((sirina/visina).le.(maxx*1./maxy)) THEN
		max_x=max_x+(visina*(maxx*1./maxy)-sirina)/2
		min_x=min_x-(visina*(maxx*1./maxy)-sirina)/2
	ELSE
		max_y=max_y+(sirina/(maxx*1./maxy)-visina)/2
		min_y=min_y-(sirina/(maxx*1./maxy)-visina)/2
	ENDIF
	CALL gswn(1,min_x,min_y,max_x,max_y)
ENDSUBROUTINE

!rauna nove koordinate tok zaradi perspektive
FUNCTION perspektiva(toc)
USE tipi
REAL max_x,min_x,max_y,min_y,max_r
integer zoomfaktor
REAL x,y
REAL fokus, f, merilo
TYPE (tocka) :: perspektiva, toc
COMMON /window/ max_x,min_x,max_y,min_y,max_r
COMMON /config1/ merilo, kot, visina_crk, barva_osi, fokus, zoomfaktor
			x=toc%x-max_x/2.-min_x/2.
			y=toc%y-max_y/2.-min_y/2.
			f=fokus*max_r 
			z=max_r-toc%z-zoomfaktor*merilo 
			perspektiva%x=f*x/(f+(z))+max_x/2.+min_x/2.
			perspektiva%y=f*y/(f+(z))+max_y/2.+min_y/2.
			perspektiva%z=0.
ENDFUNCTION

! izrise vse objekte na zaslon
SUBROUTINE izris
USE msflib
USE tipi
CHARACTER(4) t						
LOGICAL*2 tocke, robovi, ploskve, normale, pp
TYPE (objekt) :: obj(10)
TYPE (tocka) :: koor(3),nkoor(3), perspektiva, koor_izhodisce, izhodisce
TYPE (tocka), POINTER :: nt(:), ntezisce(:), nnormala(:)
REAL merilo, kot
INTEGER plci, txci, barva_osi, visina_crk
TYPE (wxycoord) wxy
COMMON /plc/ plci
COMMON /txc/ txci
COMMON /config1/ merilo, kot, visina_crk, barva_osi, fokus, zoomfaktor
COMMON /config2/ tocke, robovi, ploskve, normale, pp
COMMON /kor/ koor
COMMON /podatki/ obj
	DO j=1, 10
	IF (obj(j)%izrisi.and.obj(j)%poln) THEN
	ALLOCATE (nt(obj(j)%st_tock),ntezisce(obj(j)%st_ploskev), nnormala(obj(j)%st_ploskev), STAT = ierr)
	IF (pp) then
		DO i=1,obj(j)%st_tock
			nt(i)=perspektiva(obj(j)%v(i))
		ENDDO	
		DO i=1,obj(j)%st_ploskev
			ntezisce(i)=perspektiva(obj(j)%pl(i)%tezisce)
			nnormala(i)=perspektiva(obj(j)%pl(i)%normala)
		ENDDO
	ELSE
			nt=obj(j)%v
			ntezisce=obj(j)%pl%tezisce
			nnormala=obj(j)%pl%normala
	ENDIF
	CALL gsplci(j)
	DO i=1,obj(j)%st_robov
		CALL moveto_w(dble(nt(obj(j)%e(i)%t1)%x),dble(nt(obj(j)%e(i)%t1)%y),wxy)
		status = lineto_w(nt(obj(j)%e(i)%t2)%x,nt(obj(j)%e(i)%t2)%y)
	ENDDO	 
	IF (tocke) THEN
	DO i=1,obj(j)%st_tock
		WRITE(t,'(i3)')i
		IF (i.gt.99) THEN
		   ELSEIF (i.gt.9) THEN
		     t(1:2)=t(2:3)
			 t(3:4)='  '
		   ELSE
			 t(1:1)=t(3:3)
			 t(2:4)='   '
		ENDIF
		t='V'//t
		CALL moveto_w(dble(nt(i)%x),dble(nt(i)%y),wxy)
		CALL outgtext(t)
	ENDDO
	ENDIF
	IF (robovi) THEN
	DO i=1,obj(j)%st_robov
		WRITE(t,'(i3)')i
		IF (i.gt.99) THEN
			ELSEIF (i.gt.9) THEN
				t(1:2)=t(2:3)
				t(3:4)='  '
			ELSE
				t(1:1)=t(3:3)
				t(2:4)='   '
		ENDIF
		t='E'//t
		CALL moveto_w(dble((nt(obj(j)%e(i)%t2)%x+nt(obj(j)%e(i)%t1)%x)/2),dble((nt(obj(j)%e(i)%t2)%y+nt(obj(j)%e(i)%t1)%y)/2),wxy)
		CALL outgtext(t)
	ENDDO
	ENDIF
	DO i=1,obj(j)%st_ploskev
		IF (normale) THEN
			CALL moveto_w(dble(ntezisce(i)%x),dble(ntezisce(i)%y),wxy)
			status = lineto_w(nnormala(i)%x,nnormala(i)%y)
		ENDIF
		IF (ploskve) THEN
			WRITE(t,'(i3)')i
			IF (i.gt.99) THEN
				ELSEIF (i.gt.9) THEN
					t(1:2)=t(2:3)
					t(3:4)='  '
				ELSE
					t(1:1)=t(3:3)
					t(2:4)='   '
			ENDIF
			t='F'//t
			IF (.not.normale) CALL moveto_w(dble(ntezisce(i)%x),dble(ntezisce(i)%y),wxy)
			CALL outgtext(t)
		ENDIF	
	ENDDO		
	CALL gsplci(barva_osi)
	t=tocka(0.,0.,0.)
	DO i=1,3
		IF (pp) THEN
			koor_izhodisce=perspektiva(izhodisce)
			nkoor(i)=perspektiva(koor(i))
		ELSE
			koor_izhodisce=tocka(0,0,0)
			nkoor(i)=koor(i)
		ENDIF
		CALL moveto_w(dble(koor_izhodisce%x),dble(koor_izhodisce%y),wxy)
		status = LINETO_W(nkoor(i)%x*merilo,nkoor(i)%y*merilo)
		CALL outgtext(char(119+i))
	ENDDO
	ENDIF
	ENDDO
	nullify(nt, ntezisce, nnormala)
ENDSUBROUTINE

! bere podatke iz datoteke +++++++++++++++++++++++++++++++++++++++++
SUBROUTINE beri_podatke
USE msflib
USE tipi
INTEGER st_stevilk
REAL x,y,z , kot_v, kot
TYPE (objekt) :: obj(10)
TYPE (tocka) :: v(3)
TYPE (tocka) :: vekt_p
CHARACTER(40) ime_datoteke, vrstica
CHARACTER*80 ploskev_str
CHARACTER*1 a
COMMON /podatki/ obj
d1:	DO j=1, 10
		IF (.not.obj(j)%poln) THEN
			WRITE(*,'('' Vpisi ime datoteke: '', \)')
			READ(*,'(a)')ime_datoteke
			IF (len_trim(ime_datoteke).lt.1) EXIT d1
!			CALL clearscreen($gwindow) 
			OPEN(10,file=ime_datoteke,err=3,status='old')
			obj%sprememba=obj%poln
			CALL plan
			READ(10,'(A)')obj(j)%komentar
			READ(10,*,err=3)obj(j)%st_tock
			ALLOCATE (obj(j)%v(obj(j)%st_tock), STAT = ierr)
			DO k=1, obj(j)%st_tock
				READ(10,'(A)')vrstica
				READ(vrstica,*,err=3)obj(j)%v(k) 
			ENDDO
			READ(10,*)obj(j)%st_robov
			ALLOCATE (obj(j)%e(obj(j)%st_robov), STAT = ierr)
			DO k=1, obj(j)%st_robov
				READ(10,'(A)')vrstica
				READ(vrstica,*,err=3)obj(j)%e(k) 
			ENDDO
			READ(10,*)obj(j)%st_ploskev
			ALLOCATE (obj(j)%pl(obj(j)%st_ploskev), STAT = ierr)
			DO k=1, obj(j)%st_ploskev
				READ(10,'(A)',err=3)ploskev_str
				obj(j)%pl(k)%st_robov=st_stevilk(ploskev_str)
				READ(ploskev_str,*,err=3)(obj(j)%pl(k)%rob(n),n=1,obj(j)%pl(k)%st_robov)
			ENDDO
			CLOSE(10)
			DO k=1, obj(j)%st_ploskev
				IF ((obj(j)%pl(k)%st_robov).lt.3) THEN
					WRITE(*,'('' Ploskev '',I2,'' ima premalo robov!'')')k
					WRITE(*,'('' Pritisni karkoli...'')')
					a=getcharqq()
					GOTO 2
				ENDIF
				DO l=1,obj(j)%pl(k)%st_robov-1
				IF (.not.(obj(j)%e(obj(j)%pl(k)%rob(l))%t1.eq.obj(j)%e(obj(j)%pl(k)%rob(l+1))%t1)) then
					IF (.not.(obj(j)%e(obj(j)%pl(k)%rob(l))%t1.eq.obj(j)%e(obj(j)%pl(k)%rob(l+1))%t2)) then
						IF (.not.(obj(j)%e(obj(j)%pl(k)%rob(l))%t2.eq.obj(j)%e(obj(j)%pl(k)%rob(l+1))%t1)) then
							IF (.not.(obj(j)%e(obj(j)%pl(k)%rob(l))%t2.eq.obj(j)%e(obj(j)%pl(k)%rob(l+1))%t2)) then
								WRITE(*,'('' Ploskev '',I2,'' ni sklenjena!'')')k
								WRITE(*,'('' Pritisni karkoli...'')')
								a=getcharqq()
								GOTO 2
							ENDIF
						ENDIF
					ENDIF
				ENDIF
				ENDDO
				IF (.not.(obj(j)%e(obj(j)%pl(k)%rob(1))%t1.eq.obj(j)%e(obj(j)%pl(k)%rob(l))%t1)) then
					IF (.not.(obj(j)%e(obj(j)%pl(k)%rob(1))%t1.eq.obj(j)%e(obj(j)%pl(k)%rob(l))%t2)) then
						IF (.not.(obj(j)%e(obj(j)%pl(k)%rob(1))%t2.eq.obj(j)%e(obj(j)%pl(k)%rob(l))%t1)) then
							IF (.not.(obj(j)%e(obj(j)%pl(k)%rob(1))%t2.eq.obj(j)%e(obj(j)%pl(k)%rob(l))%t2)) then
								WRITE(*,'('' Ploskev '',I2,'' ni sklenjena!'')')k
								WRITE(*,'('' Pritisni karkoli...'')')
								a=getcharqq()
								GOTO 2
							ENDIF
						ENDIF
					ENDIF
				ENDIF
! racunanje tezisca crtovja ploskve
				x=0.
				y=0.
				z=0.
				dolzina=0.
				DO m=1,obj(j)%pl(k)%st_robov
					v(1)%x=obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m))%t2)%x-obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m))%t1)%x
					v(1)%y=obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m))%t2)%y-obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m))%t1)%y
					v(1)%z=obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m))%t2)%z-obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m))%t1)%z
					dolzina=dolzina_v(v(1))+dolzina
					x=x+(obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m))%t2)%x+obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m))%t1)%x)/2*dolzina_v(v(1))
					y=y+(obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m))%t2)%y+obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m))%t1)%y)/2*dolzina_v(v(1))
					z=z+(obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m))%t2)%z+obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m))%t1)%z)/2*dolzina_v(v(1))
				ENDDO
				x=x/dolzina
				y=y/dolzina
				z=z/dolzina
				obj(j)%pl(k)%tezisce=tocka(x,y,z)
! konec izracuna tezisca

! preverjanje koplanarnosti tock ploskve
				m=0
zanka3:			DO
					DO n=1,2
					v(n)%x=obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m+n))%t2)%x-obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m+n))%t1)%x
					v(n)%y=obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m+n))%t2)%y-obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m+n))%t1)%y
					v(n)%z=obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m+n))%t2)%z-obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(m+n))%t1)%z
					ENDDO
					v(3)=vekt_p(v(1),v(2))
					IF (dolzina_v(v(3)).gt.0.) THEN
						EXIT zanka3
					ENDIF
				m=m+1
				ENDDO zanka3
				DO i=m+1,obj(j)%pl(k)%st_robov-2
					DO n=1,2
					v(n)%x=obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(i+n))%t2)%x-obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(i+n))%t1)%x
					v(n)%y=obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(i+n))%t2)%y-obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(i+n))%t1)%y
					v(n)%z=obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(i+n))%t2)%z-obj(j)%v(obj(j)%e(obj(j)%pl(k)%rob(i+n))%t1)%z
					ENDDO
					IF ((dolzina_v(vekt_p(v(1),v(2))).ne.0)) then
						kot=kot_v(vekt_p(v(1),v(2)),v(3))
						IF (kot.gt.45) kot=kot-180
						IF (abs(kot).gt.0.1) then
							WRITE(*,'('' Tocke ploskve st.:'',I2,'' ne leijo na isti ravnini!'')')k
							WRITE(*,'('' Pritisni karkoli...'')')
							a=getcharqq()
							GOTO 2
						ENDIF
					ENDIF
				ENDDO
! konec preverjeanja koplanarnosti ploskve
   			ENDDO
			CALL nove_normale(j)
			obj(j)%poln=.true.
			obj(j)%izrisi=.true.
			obj(j)%sprememba=.true.
			GOTO 2
3			WRITE(*,'('' Napaka pri branju podatkov! Preveri vhodno datoteko!'')')
			WRITE(*,'('' Pritisni karkoli...'')')
			a=getcharqq()
			CLOSE(10)
2			CALL unplan
			EXIT d1
		ENDIF
	ENDDO d1
	IF (j.EQ.11) THEN
		WRITE(*,'('' Prevec odprtih modelov!!'')')
		WRITE(*,'('' Pritisni karkoli...'')')
		a=getcharqq()
	ENDIF
ENDSUBROUTINE


SUBROUTINE nove_normale(j)
USE tipi
TYPE (tocka) :: v(4), vekt_p
TYPE (objekt) :: obj(10)
INTEGER tocke(10,2), t(10)
COMMON /podatki/ obj
		DO k=1,obj(j)%st_ploskev
			v(3)=tocka(0,0,0)
			DO i=1,obj(j)%pl(k)%st_robov
				tocke(i,1)=obj(j)%e(obj(j)%pl(k)%rob(i))%t1
				tocke(i,2)=obj(j)%e(obj(j)%pl(k)%rob(i))%t2
			ENDDO
			IF ((tocke(1,1).ne.tocke(2,1)).and.(tocke(1,1).ne.tocke(2,2))) THEN
				t(1)=tocke(1,1)
				t(2)=tocke(1,2)
			ELSE	
				t(1)=tocke(1,2)
				t(2)=tocke(1,1)
			ENDIF

			DO i=2,	obj(j)%pl(k)%st_robov-1
				IF (t(i).ne.tocke(i,1)) then
					t(i+1)=tocke(i,1)
				ELSE
					t(i+1)=tocke(i,2)
				ENDIF
			ENDDO
			t(i+1)=t(1)
			v(4)=tocka(0,0,0)
			DO i=1, obj(j)%pl(k)%st_robov-1
				v(1)=tocka(obj(j)%v(t(i+1))%x-obj(j)%v(t(i))%x,obj(j)%v(t(i+1))%y-obj(j)%v(t(i))%y,obj(j)%v(t(i+1))%z-obj(j)%v(t(i))%z)
				v(2)=tocka(obj(j)%v(t(i+2))%x-obj(j)%v(t(i+1))%x,obj(j)%v(t(i+2))%y-obj(j)%v(t(i+1))%y,obj(j)%v(t(i+2))%z-obj(j)%v(t(i+1))%z)
				v(3)=vekt_p(v(1),v(2))
				v(4)%x=v(4)%x+v(3)%x
				v(4)%y=v(4)%y+v(3)%y
				v(4)%z=v(4)%z+v(3)%z
			ENDDO

! dolzina izrisa normale je 0.25
			obj(j)%pl(k)%normala%x=v(4)%x*0.25/dolzina_v(v(4))+obj(j)%pl(k)%tezisce%x
			obj(j)%pl(k)%normala%y=v(4)%y*0.25/dolzina_v(v(4))+obj(j)%pl(k)%tezisce%y
			obj(j)%pl(k)%normala%z=v(4)%z*0.25/dolzina_v(v(4))+obj(j)%pl(k)%tezisce%z
		ENDDO
ENDSUBROUTINE

! mnozenje vektorja z matriko
FUNCTION VZM(vektor,M)
USE tipi
REAL v1(4),v(4)
TYPE (tocka) :: vzm,vektor
REAL, dimension(4,4) :: M
	v(1)=vektor%x
	v(2)=vektor%y
	v(3)=vektor%z
	v(4)=1
	DO i=1,4
		v1(i)=0
		DO j=1,4
			v1(i)=v1(i)+M(i,j)*v(j)
		ENDDO
	ENDDO
	VZM=tocka(v1(1),v1(2),v1(3))
ENDFUNCTION

! Translatorni premik toke (tx,ty,tz) za dx,dy,dz
SUBROUTINE premik_tock(dv) 
USE tipi
TYPE (objekt) :: obj(10)
TYPE (tocka) :: dv
REAL, dimension(4,4) :: M
COMMON /podatki/ obj
	CALL enotska_matrika(M)
	M(1,4)=dv%x
	M(2,4)=dv%y
	M(3,4)=dv%z
	DO j=1, 10
		IF (obj(j)%sprememba) CALL racunaj(j,M)
	ENDDO
ENDSUBROUTINE

! preracun tock
SUBROUTINE racunaj(j,M)
USE tipi
TYPE (objekt) :: obj(10)
TYPE (tocka) :: vzm
COMMON /podatki/ obj
REAL, dimension(4,4) :: M
	DO i=1,obj(j)%st_tock
		obj(j)%v(i) = VZM(obj(j)%v(i),M)
	ENDDO
	DO i=1,obj(j)%st_ploskev
		obj(j)%pl(i)%tezisce = vzm(obj(j)%pl(i)%tezisce,M)
		obj(j)%pl(i)%normala = vzm(obj(j)%pl(i)%normala,M)
	ENDDO
ENDSUBROUTINE

! skaliranje tocke za faktor 'scale' == (x,y,z)
SUBROUTINE skalacija_tocke(scale)
USE tipi
TYPE (objekt) :: obj(10)
TYPE (tocka) :: scale
REAL, dimension(4,4) :: M
COMMON /podatki/ obj
	CALL enotska_matrika(M)
	M(1,1)=scale%x
	M(2,2)=scale%y
	M(3,3)=scale%z
	DO j=1, 10
		IF (obj(j)%sprememba) THEN
			CALL racunaj(j,M)
			CALL nove_normale(j)
		ENDIF
	ENDDO
ENDSUBROUTINE

! kreira enotsko matriko
SUBROUTINE enotska_matrika(E)
REAL, dimension(4,4):: E
	E=0
	DO i=1, 4 
		E(i,i)=1
	ENDDO
RETURN
ENDSUBROUTINE

! izbere objekt
SUBROUTINE kateri_objekti
USE tipi
USE msflib
TYPE (objekt) :: obj(10)
TYPE (wxycoord) wxy
REAL max_x,min_x,max_y,min_y,x,y,max_r
INTEGER o(10),st_obj, st_stevilk
CHARACTER*80 objekti_str
CHARACTER*2 stev
COMMON /podatki/ obj
COMMON /window/ max_x,min_x,max_y,min_y,max_r
x=min_x+(max_x-min_x)*.01
y=max_y
i=0
	DO j=1,10
		IF (obj(j)%poln) THEN
		    i=i+1
			y=y-(max_y-min_y)*.05
			CALL moveto_w(dble(x),dble(y),wxy)
			WRITE(stev,'(i2)')j
			CALL gsplci(j)
			CALL outgtext(stev//'. '//obj(j)%komentar)
		ENDIF
	ENDDO
	obj%sprememba=.false.
	WRITE(*,'('' Kateri objekti? (<enter> za vse) '',\)')
	READ(*,'(a)')objekti_str
	IF (objekti_str.NE.'') THEN
		st_obj=st_stevilk(objekti_str)
		READ(objekti_str,*)(o(i),i=1,st_obj)
		DO i=1,st_obj
			obj(o(i))%sprememba=.true.
		ENDDO
	ELSE
		obj%sprememba=obj%poln
	ENDIF
ENDSUBROUTINE

! brise objekt iz spomina
SUBROUTINE brisi_objekt
USE tipi
USE msflib
TYPE (objekt) :: obj(10)
TYPE (wxycoord) wxy
REAL max_x,min_x,max_y,min_y,x,y,max_r
CHARACTER*2 stev
INTEGER o(10),st_obj  , st_stevilk
CHARACTER*80 objekti_str
COMMON /podatki/ obj
COMMON /window/ max_x,min_x,max_y,min_y,max_r
x=min_x+(max_x-min_x)*.01
y=max_y
	i=0
	DO j=1,10
		IF (obj(j)%poln) THEN
		    i=i+1
			y=y-(max_y-min_y)*.05
			CALL moveto_w(dble(x),dble(y),wxy)
			WRITE(stev,'(i2)')j
			CALL gsplci(j)
			CALL outgtext(stev//'. '//obj(j)%komentar)
		ENDIF
	ENDDO
	WRITE(*,*)'Brisanje objektov'
	WRITE(*,'('' Kateri objekti? (<enter> prekini) '',\)')
	READ(*,'(a)')objekti_str
	IF (objekti_str.NE.'') THEN
		st_obj=st_stevilk(objekti_str)
		READ(objekti_str,*)(o(i),i=1,st_obj)
		DO i=1,st_obj
			IF ((o(i).lt.11).and.(o(i).gt.0)) THEN
				NULLIFY(obj(o(i))%v)
				NULLIFY(obj(o(i))%e)
				NULLIFY(obj(o(i))%pl)
				obj(o(i))%poln=.false.
				obj(o(i))%izrisi=.false.
			ENDIF
		ENDDO
	ENDIF
ENDSUBROUTINE


!-------- rotacija okoli osi----------
!Izvaja rotacijo toke. dfi - kot rotacije, 
!			rot - logical (ali obrne tudi koor. sistem?)
!			a - character (x,y ali z)
SUBROUTINE rotacija_tocke(dfi,rot,a)
USE tipi
TYPE (objekt) :: obj(10)
TYPE (tocka) :: vzm
LOGICAL rot
REAL, dimension(4,4) :: M
REAL dfi                   
CHARACTER*1 a
TYPE (tocka) :: koor(3)
COMMON /kor/ koor
COMMON /podatki/ obj
	CALL enotska_matrika(M)
SELECT CASE (a)
	CASE ('x','X')
		M(2,2)=cos(dfi)
		M(3,2)=sin(dfi)
		M(2,3)=-sin(dfi)
		M(3,3)=cos(dfi)
	CASE ('y','Y')
		M(1,1)=cos(dfi)
		M(3,1)=-sin(dfi)
		M(1,3)=sin(dfi)
		M(3,3)=cos(dfi)
	CASE ('z','Z')
		M(1,1)=cos(dfi)
		M(2,1)=sin(dfi)
		M(1,2)=-sin(dfi)
		M(2,2)=cos(dfi)
END SELECT
	DO j=1, 10
		IF (obj(j)%sprememba) CALL racunaj(j,M)
	ENDDO
	IF (rot) THEN
		DO i=1,3
			koor(i) = vzm(koor(i),M)
		ENDDO
	ENDIF
ENDSUBROUTINE

! pretvorba kotnih stopinj v radiane +++++++++++++++++++++++++++++++
FUNCTION deg2rad(deg)
REAL deg
	deg2rad=deg*3.1415926/180
ENDFUNCTION

! ugotovi st. stevilk v stringu a+++++++++++++++++++++++++++++++++++
FUNCTION st_stevilk(a)
INTEGER stev, st_stevilk
CHARACTER*80 a
	stev=0
	n=len_trim(a)
	DO i=1,n
		IF (ichar(a(i:i)).eq.(ichar(' ')).or.(ichar(a(i:i)).eq.9)) THEN
		stev=stev+1
		IF (ichar(a(i-1:i-1)).eq.(ichar(' ')).or.(ichar(a(i-1:i-1)).eq.9)) stev=stev-1
		ENDIF
	ENDDO
	IF (ichar(a(1:1)).eq.(ichar(' ')).or.(ichar(a(1:1)).eq.9)) stev=stev-1
	IF (ichar(a(n:n)).eq.(ichar(' ')).or.(ichar(a(n:n)).eq.9)) stev=stev-1
	st_stevilk=stev+1
ENDFUNCTION

! zoom out---------------------------------------------------------
SUBROUTINE zoom_out
REAL max_x,min_x,max_y,min_y,sirina,visina
LOGICAL*2 tocke, robovi, ploskve, normale, pp
COMMON /window/	max_x,min_x,max_y,min_y,max_r
COMMON /config2/ tocke, robovi, ploskve, normale, pp
IF (.not.pp) THEN
	sirina=max_x-min_x
	visina=max_y-min_y
	min_x=min_x-.1*(sirina)
	max_x=max_x+.1*(sirina)
	min_y=min_y-.1*(visina)
	max_y=max_y+.1*(visina)
ENDIF
CALL gcls
CALL gswn(1,min_x,min_y,max_x,max_y)
ENDSUBROUTINE

! zoom in -------------------------------------------------
SUBROUTINE zoom_in
REAL max_x,min_x,max_y,min_y,sirina,visina
LOGICAL*2 tocke, robovi, ploskve, normale, pp
COMMON /window/	max_x,min_x,max_y,min_y,max_r
COMMON /config2/ tocke, robovi, ploskve, normale, pp
IF (.not.pp) then
	sirina=max_x-min_x
	visina=max_y-min_y
	min_x=min_x+.1*(sirina)
	max_x=max_x-.1*(sirina)
	min_y=min_y+.1*(visina)
	max_y=max_y-.1*(visina)
ENDIF
CALL gcls
CALL gswn(1,min_x,min_y,max_x,max_y)
ENDSUBROUTINE


!premik zaslona (gor, dol, levo, desno)
SUBROUTINE levo
REAL max_x,min_x,max_y,min_y,sirina
COMMON /window/ max_x,min_x,max_y,min_y,max_r
	sirina=max_x-min_x
	min_x=min_x-.01*(sirina)
	max_x=max_x-.01*(sirina)
	CALL gcls
	CALL gswn(1,min_x,min_y,max_x,max_y)
ENDSUBROUTINE

SUBROUTINE desno
REAL max_x,min_x,max_y,min_y,sirina
COMMON /window/ max_x,min_x,max_y,min_y,max_r
	sirina=max_x-min_x
	min_x=min_x+.01*(sirina)
	max_x=max_x+.01*(sirina)
	CALL gcls
	CALL gswn(1,min_x,min_y,max_x,max_y)
ENDSUBROUTINE
												  
SUBROUTINE gor
REAL max_x,min_x,max_y,min_y,visina
COMMON /window/ max_x,min_x,max_y,min_y,max_r
	visina=max_y-min_y
	min_y=min_y+.01*(visina)
	max_y=max_y+.01*(visina)
	CALL gcls
	CALL gswn(1,min_x,min_y,max_x,max_y)
ENDSUBROUTINE

SUBROUTINE dol
REAL max_x,min_x,max_y,min_y,visina
COMMON /window/ max_x,min_x,max_y,min_y,max_r
	visina=max_y-min_y
	min_y=min_y-.01*(visina)
	max_y=max_y-.01*(visina)
	CALL gcls
	CALL gswn(1,min_x,min_y,max_x,max_y)
ENDSUBROUTINE

! shrani vse modele v pomnilniku v datoteko IME
SUBROUTINE shrani_vse(ime)
USE msflib
USE tipi
INTEGER visina_crk, barva_osi, st_obj
REAL kot, merilo, fix, fiy, fiz
LOGICAL*2 tocke, robovi, ploskve, normale, pp
TYPE (objekt) :: obj(10)
character*30 ime
COMMON /fiji/ fix,fiy,fiz
COMMON /podatki/ obj
COMMON /config1/ merilo, kot, visina_crk, barva_osi, fokus, zoomfaktor
COMMON /config2/ tocke, robovi, ploskve, normale, pp
st_obj=0
do j=1, 10
	if (obj(j)%poln) st_obj=st_obj+1
enddo
	OPEN(10,file=ime)
	obj%sprememba=obj%poln
	CALL plan
	WRITE(10,'(i3)')st_obj
	DO j=1, 10
		IF (obj(j)%poln) THEN
			WRITE(10,'(I3)')j
			WRITE(10,'(A)')obj(j)%komentar
			WRITE(10,'(I3)')obj(j)%st_tock
			DO k=1, obj(j)%st_tock
				WRITE(10,*)obj(j)%v(k) 
			ENDDO
			WRITE(10,'(I3)')obj(j)%st_robov
			DO k=1, obj(j)%st_robov
				WRITE(10,*)obj(j)%e(k) 
			ENDDO
			WRITE(10,'(I3)')obj(j)%st_ploskev
			DO k=1, obj(j)%st_ploskev
				WRITE(10,*)(obj(j)%pl(k)%rob(n),n=1,obj(j)%pl(k)%st_robov)
				WRITE(10,*)obj(j)%pl(k)%tezisce
				WRITE(10,*)obj(j)%pl(k)%normala
			ENDDO
		ENDIF
	ENDDO
	WRITE(10,*)fix,fiy,fiz
	WRITE(10,*)merilo, kot, visina_crk, barva_osi, tocke, robovi, ploskve, normale, pp
	close(10)
ENDSUBROUTINE

! brie pomnilnik in naloi modele v datoteki IME
SUBROUTINE beri_vse(ime)
USE msflib
USE tipi
INTEGER visina_crk, barva_osi, st_obj, st_stevilk
REAL merilo, kot, fokus		 
REAL fix, fiy, fiz 
LOGICAL*2 tocke, robovi, ploskve, normale, pp
TYPE (objekt) :: obj(10)
character*30 ime
character*255 vrstica, ploskev_str
COMMON /fiji/ fix,fiy,fiz
COMMON /podatki/ obj
COMMON /config1/ merilo, kot, visina_crk, barva_osi, fokus, zoomfaktor
COMMON /config2/ tocke, robovi, ploskve, normale, pp
	OPEN(10,file=ime)
	read(10,*)st_obj
	DO i=1, st_obj
			READ(10,*)j
			READ(10,'(A)')obj(j)%komentar
			READ(10,*)obj(j)%st_tock
			ALLOCATE (obj(j)%v(obj(j)%st_tock), STAT = ierr)
			DO k=1, obj(j)%st_tock
				READ(10,'(A)')vrstica
				READ(vrstica,*)obj(j)%v(k) 
			ENDDO
			READ(10,*)obj(j)%st_robov
			ALLOCATE (obj(j)%e(obj(j)%st_robov), STAT = ierr)
			DO k=1, obj(j)%st_robov
				READ(10,'(A)')vrstica
				READ(vrstica,*)obj(j)%e(k) 
			ENDDO
			READ(10,*)obj(j)%st_ploskev
			ALLOCATE (obj(j)%pl(obj(j)%st_ploskev), STAT = ierr)
			DO k=1, obj(j)%st_ploskev
				READ(10,'(A)')ploskev_str
				READ(10,*)obj(j)%pl(k)%tezisce
				READ(10,*)obj(j)%pl(k)%normala
				obj(j)%pl(k)%st_robov=st_stevilk(ploskev_str)
				READ(ploskev_str,*)(obj(j)%pl(k)%rob(n),n=1,obj(j)%pl(k)%st_robov)
			ENDDO
	obj(j)%poln=.true.
	obj(j)%izrisi=.true.
	ENDDO
	read(10,*)fix,fiy,fiz
	READ(10,*)merilo, kot, visina_crk, barva_osi, tocke, robovi, ploskve, normale, pp
	obj%sprememba=obj%poln
	call unplan
	call init_window
	call izris
	close(10)
ENDSUBROUTINE

! vrne vektorski produkt med vektorjema v1 in v2
FUNCTION vekt_p(v1,v2)
USE tipi
TYPE (tocka) :: v1,v2,vekt_p
vekt_p=tocka(v1%y*v2%z-v1%z*v2%y,v1%z*v2%x-v1%x*v2%z,v1%x*v2%y-v1%y*v2%x)
ENDFUNCTION

! vrne skalarni produkt med vektorjema v1 in v2
FUNCTION skal_p(v1,v2)
USE tipi
REAL skal_p
TYPE (tocka) :: v1,v2
skal_p=v1%x*v2%x+v1%y*v2%y+v1%z*v2%z
ENDFUNCTION

! vrne enotski vektor vektorja v1
FUNCTION enotski_v(v1)
USE tipi
REAL dolzina
TYPE (tocka) :: v1,enotski_v
dolzina=dolzina_v(v1)
enotski_v=tocka(v1%x/dolzina, v1%y/dolzina, v1%z/dolzina)
ENDFUNCTION

! vrne dolino vektorja v1. matematino - |v1|
FUNCTION dolzina_v(v1)
USE tipi
REAL dolzina_v
TYPE (tocka) :: v1
dolzina_v=sqrt(v1%x**2+v1%y**2+v1%z**2)
ENDFUNCTION

!vrne kot med vektorjema v1 in v2
FUNCTION kot_v(v1,v2)
USE tipi
REAL kot_v
TYPE (tocka) :: v1,v2
kot_v=acosd(skal_p(v1,v2)/(dolzina_v(v1)*dolzina_v(v2)))
ENDFUNCTION


!------- the END -------- 